unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComPort;

type
  TfrmMain = class(TForm)
    tbBaudRate: TEdit;
    lbBaudRate: TLabel;
    tbPortNumber: TEdit;
    lbComNumber: TLabel;
    tbRTimeOut: TEdit;
    lbRTimeOut: TLabel;
    tbWTimeOut: TEdit;
    lbWTimeOut: TLabel;
    mmNote: TMemo;
    GroupBox1: TGroupBox;
    tbWrite: TEdit;
    cbCRLF: TCheckBox;
    btWrite: TButton;
    btOpen: TButton;
    gbRead: TGroupBox;
    mmRead: TMemo;
    btRead: TButton;
    procedure btOpenClick(Sender: TObject);
    procedure btWriteClick(Sender: TObject);
    procedure btReadClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  ComPort_ : TComPort;
implementation

{$R *.dfm}

procedure TfrmMain.btOpenClick(Sender: TObject);
begin
  try
    ComPort_ := TComPort.Create(StrToInt(tbBaudRate.Text),
                                StrToInt(tbPortNumber.Text));
    ComPort_.ReadTimeOut := StrToInt(tbRTimeOut.Text);
    ComPort_.WriteTimeOut := StrToInt(tbWTimeOut.Text);
  except
    ShowMessage('Exception, perhaps you typed wrong port number/baud rate/timeouts');
    exit;
  end;

  if (not ComPort_.Open()) then
  begin
    ShowMessage('Can not open port :(');
  end else
  begin
    ShowMessage('Opened :)');
  end;
end;

procedure TfrmMain.btWriteClick(Sender: TObject);
var
  toSend : string;
begin
  if (ComPort_ = nil) then
  begin
    exit;
  end;

  toSend := tbWrite.Text;
  if (cbCRLF.Checked) then
  begin
    toSend := toSend + #13#10;
  end;
  if (ComPort_.Write(toSend)) then
  begin
    ShowMessage('Congrats, it was sent :)');
  end else
  begin
    ShowMessage('Write Error :(');
  end;
end;

procedure TfrmMain.btReadClick(Sender: TObject);
var
  readBuf : string;
begin
  if (ComPort_ = nil) then
  begin
    exit;
  end;


  readBuf := '';
  readBuf := ComPort_.Read();
  if (readBuf <> '') then
  begin
    mmRead.Text := readBuf;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  ComPort_ := nil;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ComPort_.Close();
  ComPort_.Free;
end;

end.
